<script setup lang="ts">
const props = defineProps<{ header: string; hash: string }>();

const { setPanelVisibility, isPanelOpen, setPanelOpenness } =
  useDetailsPanelsStore();

const intersectOptions = {
  // @TODO: programmatically get the app bar height
  rootMargin: "-66px 0px 0px 0px",
};

const onIntersect = (isIntersecting: boolean) => {
  setPanelVisibility(props.hash, isIntersecting);
};
</script>

<template>
  <v-expansion-panels
    :id="props.hash"
    :model-value="isPanelOpen(props.hash) ? props.hash : null"
    @update:model-value="(v: any) => setPanelOpenness(props.hash, !!v)"
  >
    <v-expansion-panel
      v-intersect="{
        handler: onIntersect,
        options: intersectOptions,
      }"
      :value="props.hash"
      elevation="0"
      class="rounded-0"
    >
      <v-expansion-panel-title>
        <span
          class="details-panel-header"
          :class="{ 'text-h6': isPanelOpen(props.hash) }"
        >
          {{ header }}
        </span>
      </v-expansion-panel-title>

      <v-expansion-panel-text eager>
        <slot />
      </v-expansion-panel-text>
    </v-expansion-panel>
    <v-divider />
  </v-expansion-panels>
</template>

<style scoped>
.details-panel-header {
  transition: all 0.3s cubic-bezier(0.25, 0.8, 0.5, 1);
}
</style>
